import contextlib
import unittest
import io
import unittest.mock
import numpy as np
from unittest import TextTestRunner


class MainTest(unittest.TestCase):

    def test_answer_one(self):
        
        X = np.array([[66, 5, 15, 2, 500], [21, 3, 50, 1, 100], [120, 15, 5, 2, 1200]])
        y = np.array([250000, 60000, 525000])
        c = np.array([3000, 200 , -50, 5000, 100]) 

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        squared_error(X, y, c)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '1367335000.0', "Did not pass all test cases, please review your code and ensure it handles any number of cabins and coefficients.")

    def test_answer_two(self):

        X2 = np.array([[66, 5, 15, 2, 500, -10], [21, 3, 50, 1, 100, 0], [120, 15, 5, 2, 1200, 10], [1, 2, 3, 4, 5, 6]])
        c2 = np.array([3000, 200 , -50, 5000, 100, 50])
        y2 = np.array([250000, 70000, 500000, 20000])

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        squared_error(X2, y2, c2)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '159237500.0', "Did not pass all test cases, please review your code and ensure it handles any number of cabins and coefficients.")

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())
