import unittest, sys
import io
import unittest.mock
import numpy as np

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'squared_error')

@points('3-2')
class MainTest(unittest.TestCase):
    
    def test_answer_one(self):
        X = np.array([[66, 5, 15, 2, 500], [21, 3, 50, 1, 100], [120, 15, 5, 2, 1200]])
        y = np.array([250000, 60000, 525000])
        c = np.array([3000, 200 , -50, 5000, 100]) 
        main(X, y, c)
        output = get_out()
        self.assertEqual(output, '1367335000.0')

    def test_answer_two(self):
        X2 = np.array([[66, 5, 15, 2, 500, -10], [21, 3, 50, 1, 100, 0], [120, 15, 5, 2, 1200, 10], [1, 2, 3, 4, 5, 6]])
        c2 = np.array([3000, 200 , -50, 5000, 100, 50])
        y2 = np.array([250000, 70000, 500000, 20000])
        main(X2, y2, c2)
        output = get_out()
        self.assertEqual(output, '159237500.0')


if __name__ == '__main__':
    unittest.main()
